//+----------------------------------------------------------------------------------------+
//|                                                   5/10 MA Cross w RSI and Stoch Filter |
//|                                                   Ian Boersma - Copyright 2006         |              
//|                                                                                        |
//+----------------------------------------------------------------------------------------+
#property copyright "Ian Boersma"
    

//---- input parameters
extern double    TakeProfit=100;
extern double    Lots=1;
extern double    TrailingStop=35;

extern int ShortEma = 5;
extern int LongWma = 10;
extern int RSIPer = 14;
extern int StochK = 10;
extern int StochD = 3;
extern int StochSlow = 3;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            +
//| This is where we initialize internal variables for program use   +                                    |
//+------------------------------------------------------------------+
int start() 
  {
//---- 

   //LotCalc Declarations
   int cnt, ticket, total;
   //MAs and Filter Variable Declarations
   double RSI;
   double Stoch;
   double EMA1,EMA2,WMA1,WMA2;
   
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
     
   //MA and Filter Variable Definition  
   EMA1 = iMA(NULL,0,ShortEma,0,MODE_EMA,PRICE_CLOSE,0);
   WMA1 = iMA(NULL,0,LongWma,0,MODE_LWMA,PRICE_CLOSE,0);
   EMA2 = iMA(NULL,0,ShortEma,0,MODE_EMA,PRICE_CLOSE,1);
   WMA2 = iMA(NULL,0,LongWma,0,MODE_LWMA,PRICE_CLOSE,1);
   RSI = iRSI(NULL,0,RSIPer,PRICE_CLOSE,0);
   Stoch = iStochastic(NULL,0,StochK,StochD,StochSlow,MODE_SMA,0,MODE_MAIN,0);
   
   int isCrossed  = 0;
    
    if (EMA1 > WMA1 && EMA2 <= WMA2 && RSI >= 50 && Stoch < 80)
    {isCrossed = 1;
    }

    if (EMA1 < WMA1 && EMA2 >= WMA2 && RSI <= 50 && Stoch > 20)
    {isCrossed = 2;
    }

    
   //We check the trading terminal to see if it is empty
   total  = OrdersTotal(); 
   if(total < 1) //If trading terminal is empty...
     {
      if(isCrossed == 1) //if cross indicates LONG swing...
       

         {
            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,2,0,Ask+TakeProfit*Point,"My EA",12345,0,Yellow);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
              }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }
        if(isCrossed == 2) //if cross indicates SHORT swing...
      
         {

            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,2,0,Bid-TakeProfit*Point,"My EA",12345,0,Red);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
              }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
         return(0);
     }
   
   //Position exit function...
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      OrderPrint();
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // Check if we have a SHORT cross condition...
           if(isCrossed == 2)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // Check our trailing stop to see if it needs to be adjusted
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // Check if we have a LONG cross condition...
            if(isCrossed == 1)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // Check our trailing stop to see if it needs to be adjuste
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }

   return(0);
  }
//+------------------------------------------------------------------+